-- START CONFIGURATION

-- Server details:
-- Set the following parameters to match your own IGUANA instance.
local server =                {}
server.params =               {}
server.url =                  'http://localhost:6543' -- The URL/port of the IGUANA instance to monitor
server.params.UserName =      'admin'                 -- The username of the IGUANA instance to monitor
server.params.Password =      'password'              -- The password of the IGUANA instance to monitor
server.params.ChannelName =   'Twilio: Example'       -- The name of the channel to monitor
server.params.ChannelAction = 'Start'                 -- The action to take (leave as 'start')
server.params.Format =        'text'                  -- The format for the command (leave as 'text')

-- Twilio details:
-- Set the following parameters to configure your calls and actions.
local twilio = {}
twilio.iguanaURL = 'http://iguana:6544/twilio' -- The publically accessible URL/port for this web service 
twilio.voice =     'woman'                     -- The gender of the voice (per Twilio's options)
twilio.name =      'Iguana enthusiast'         -- Your name or the name of the person to be addressed


-- END CONFIGURATION

function main(Data)
   
   local response = initiate
   
   local request = net.http.parseRequest{data=Data}
   
   if request.get_params.cmd == 'restart' then       
      net.http.post{
         url=server.url .. '/status.html',
         parameters=server.params, 
         live=false
      }      
      response = restart
   end
   
   net.http.respond{body=response}
   
end


-- TWILIO TEMPLATES:
-- Notification of problem:

initiate = [[
<?xml version="1.0" encoding="UTF-8"?>
   <Response>
        <Gather 
            finishOnKey="2"
            numDigits = "1" 
            action = "]] .. twilio.iguanaURL .. [[?cmd=restart"
            method="POST">
            <Say voice="]] .. twilio.voice .. [[">
                   Hello ]] .. twilio.name .. [[. I thought you'd want to know that your channel 
                   has stopped running. If you would like me to restart it 
                   for you, please press one now.  Otherwise, you may press 
                   two and ignore this warning.
            </Say>
       </Gather>
       <Say voice="]] .. twilio.voice .. [[">Thank you, I hope you've made the right decision.</Say>
   </Response>
]]

-- Confirmation of action:

restart = [[
<?xml version="1.0" encoding="UTF-8"?>
   <Response>
      <Say voice="]] .. twilio.voice .. [[">Thank you, your channel has been restarted. Goodbye.</Say>
   </Response>
]]